public class worldFunc{
    static vectorFunc v = new vectorFunc();
    static atomFunc a = new atomFunc();
    
    public static world resetForce(world olWorld)    // reset force accumulator
    {
        world nuWorld = new world(olWorld);
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuWorld.append(a.zeroforce(olWorld.atomLst[i]));
        }
        return nuWorld;
    }
    
    //martin modif   now completly functional
    //in a world were A B and C interact, A move in a world were B and C havent moved
    //B move in a world were A moved but not C, then C move in a world were A and B move
    //i changed that. Now A move in a world were B and C havent move, no change.
    //B move in a world wera A and C havent moved, then C move in a world were B and A havent move
    //keep a save of the world before transformation, then transform form that data.
    
    public static world interAtomCollisionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        
       // for (int i=0;i<olWorld.atomQty;i++)
        {
        //    nuAtom = new atom(olWorld.atomLst[i]);
        //    int cx = (int)(nuAtom.pos.x / 10);
        //    int cy = (int)(nuAtom.pos.y / 10);
            //grid[cx,cy].Add(i);
        }
        
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuAtom = new atom(olWorld.atomLst[i]);
         //   int cx = (int)(nuAtom.pos.x / 10);
         //   int cy = (int)(nuAtom.pos.y / 10);
            
            boolean istate = a.getrest(nuAtom);
            //for (int gx = cx - 1; gx < cy + 2; gx++)
            //{
               // for (int gy = cy -1; gy < cy + 2; gy++)
               // {
                  //  if (gx < cx+2 && gx > cx-2 && gy < cy+2 && gy > cy-2)
                  //  {
                   //   for (j=0; 
                for (int j=0; j<olWorld.atomQty; j++)
                {
                    if (i!=j)
                    {
                        boolean jstate = a.getrest(olWorld.atomLst[j]);
                        
                        if ((istate == false && jstate == false) || (istate == true && jstate == false))
                        {
                            vector link = v.sub(a.getpos(nuAtom), a.getpos(olWorld.atomLst[j]));    // get direction vector
                            double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                            double restlenght = a.sizes(olWorld.atomLst[i], olWorld.atomLst[j]);     // get collision threshold

                            if (distCentersSQ == 0.0f)                                              // check if position overlap
                            {
                                //System.out.println("centers distance: "+ distCentersSQ +" , restlenght:" + restlenght);    // <---- BROKEN, WHY????
                                nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                                nuAtom = a.unrest(nuAtom);
                            }
                            else if (distCentersSQ < restlenght*restlenght)                         // check if collide
                            {
                                //System.out.println("distance from centers: "+ distCentersSQ + " , rest:" + restlenght);    // <---- BROKEN, WHY????
                                nuAtom = a.addforce(nuAtom, a.repulse(nuAtom, olWorld.atomLst[j], restlenght, distCentersSQ));
                                nuAtom = a.unrest(nuAtom);
                            }
                        } 
                    }
                }
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world boxCollisionDetectionResponse(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        for (int i=0;i<olWorld.atomQty;i++)
        {
            nuAtom = olWorld.atomLst[i];
            nuAtom = a.hardcollision(nuAtom, olWorld.boxSize, olWorld.boxPos, olWorld.surfBounce, olWorld.surfFriction);
            nuAtom = a.terminalvelocity(nuAtom);
            nuAtom = a.velocitydrag(nuAtom);
            nuAtom = a.restingTest(nuAtom);
                        
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world environmentalForce(world olWorld)
    {
        world nuWorld = new world(olWorld);
        atom nuAtom;
        for (int i=0;i<olWorld.atomQty;i++)
        { 
            nuAtom = olWorld.atomLst[i];
            nuAtom = a.gravity(nuAtom, olWorld.gravity);
            nuAtom = a.terminalforces(nuAtom);
            //wind
            //etc
            nuWorld.append(nuAtom);
        }
        return nuWorld;
    }
    
    public static world integrate(world olWorld, double deltaT)
    {
        world nuWorld = new world(olWorld);
        for (int i=0;i<olWorld.atomQty;i++)
        {
           // if (a.getrest(olWorld.atomLst[i]) == false)         // integrate if not at rest
            {
                nuWorld.append(a.integrate(olWorld.atomLst[i], deltaT));
            }
            //else
            {
             //   nuWorld.append(olWorld.atomLst[i]);             // just copy if at rest
            }
        }
        return nuWorld;
    }
    

};
